/*

	ClassicMACD.mq5
	Copyright 2021, Orchard Forex
	https://www.orchardforex.com

*/

#property copyright "Copyright 2021, Orchard Forex"
#property link      "https://www.orchardforex.com"
#property version   "1.00"
#property strict

//	For MQL5 use the CTrade class
//	This is a candidate for the modular approach soon
#include			<Trade/Trade.mqh>
CTrade			Trade;
CPositionInfo	PositionInfo;

//	Common code
#include "ClassicMACD.mqh"

//	Handles initialisation specific to mql5
void	VersionInit() {

	//	Initialise the magic number in MQL5
	//	also a candidate for the common toolbox
	Trade.SetExpertMagicNumber(InpMagicNumber);

}

int	TradeCount() {
	int	result	=	0;
	int	count		=	PositionsTotal();
	for (int i=count-1; i>=0; i--) {
		if (PositionGetTicket(i)<=0) continue;
		if (PositionInfo.Symbol()==Symbol() && PositionInfo.Magic()==InpMagicNumber) result++;
	}
	return(result);
}

//	Handles trade opening specific to mql5
bool	VersionOpenTrade(ENUM_ORDER_TYPE type, double price, double sl, double tp) {

	return(Trade.PositionOpen(Symbol(), type, InpOrderSize, price, sl, tp, InpTradeComment));

}


